<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: MediaBlackbox Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classMediaBlackbox.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-static-methods">Static Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">MediaBlackbox Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Media API class Creates a pipeline internally and provides methods to start, stop and set media sources.  
 <a href="classMediaBlackbox.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="media__framework_8hpp_source.html">media_framework.hpp</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for MediaBlackbox:</div>
<div class="dyncontent">
<div class="center"><iframe scrolling="no" frameborder="0" src="classMediaBlackbox__coll__graph.svg" width="342" height="471"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
<center><span class="legend">[<a target="top" href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a9fc612bd5058aaccc9134e2965a5b125"><td class="memItemLeft" align="right" valign="top"><a id="a9fc612bd5058aaccc9134e2965a5b125"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#a9fc612bd5058aaccc9134e2965a5b125">MediaBlackbox</a> ()</td></tr>
<tr class="memdesc:a9fc612bd5058aaccc9134e2965a5b125"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates elements to build our pipeline with and links all audio and video elements. <br /></td></tr>
<tr class="separator:a9fc612bd5058aaccc9134e2965a5b125"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a364cc46ae31617c55f31ace0567fae33"><td class="memItemLeft" align="right" valign="top"><a id="a364cc46ae31617c55f31ace0567fae33"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_saturation</b> (double saturation)</td></tr>
<tr class="separator:a364cc46ae31617c55f31ace0567fae33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91b00710fe30dc390c6a10d697ed2693"><td class="memItemLeft" align="right" valign="top"><a id="a91b00710fe30dc390c6a10d697ed2693"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#a91b00710fe30dc390c6a10d697ed2693">start_media</a> ()</td></tr>
<tr class="memdesc:a91b00710fe30dc390c6a10d697ed2693"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start playing the currently set media source. <br /></td></tr>
<tr class="separator:a91b00710fe30dc390c6a10d697ed2693"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2aab2cedb799e30419eb1892e02dfb11"><td class="memItemLeft" align="right" valign="top"><a id="a2aab2cedb799e30419eb1892e02dfb11"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#a2aab2cedb799e30419eb1892e02dfb11">pause_media</a> ()</td></tr>
<tr class="memdesc:a2aab2cedb799e30419eb1892e02dfb11"><td class="mdescLeft">&#160;</td><td class="mdescRight">pause playing the currently selected media source (pausing) <br /></td></tr>
<tr class="separator:a2aab2cedb799e30419eb1892e02dfb11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af26eb9f26f51ac6ec06b7c9314bf3ab4"><td class="memItemLeft" align="right" valign="top"><a id="af26eb9f26f51ac6ec06b7c9314bf3ab4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#af26eb9f26f51ac6ec06b7c9314bf3ab4">stop_media</a> ()</td></tr>
<tr class="memdesc:af26eb9f26f51ac6ec06b7c9314bf3ab4"><td class="mdescLeft">&#160;</td><td class="mdescRight">stop the pipeline and set its state to Null Needs to be called at the end of main function <br /></td></tr>
<tr class="separator:af26eb9f26f51ac6ec06b7c9314bf3ab4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62c6e8f750e5ed03862f6b09c3ec9811"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#a62c6e8f750e5ed03862f6b09c3ec9811">set_media_src</a> (std::string file_path)</td></tr>
<tr class="memdesc:a62c6e8f750e5ed03862f6b09c3ec9811"><td class="mdescLeft">&#160;</td><td class="mdescRight">Setting the currently selected.  <a href="classMediaBlackbox.html#a62c6e8f750e5ed03862f6b09c3ec9811">More...</a><br /></td></tr>
<tr class="separator:a62c6e8f750e5ed03862f6b09c3ec9811"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada1c5730f5e98336a63ff22abcbd1ea6"><td class="memItemLeft" align="right" valign="top"><a id="ada1c5730f5e98336a63ff22abcbd1ea6"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#ada1c5730f5e98336a63ff22abcbd1ea6">bus_loop</a> ()</td></tr>
<tr class="memdesc:ada1c5730f5e98336a63ff22abcbd1ea6"><td class="mdescLeft">&#160;</td><td class="mdescRight">listens to bus <br /></td></tr>
<tr class="separator:ada1c5730f5e98336a63ff22abcbd1ea6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa267457fa1d640a4a92da0588b875454"><td class="memItemLeft" align="right" valign="top">gst::State&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#aa267457fa1d640a4a92da0588b875454">get_pipeline_state</a> ()</td></tr>
<tr class="memdesc:aa267457fa1d640a4a92da0588b875454"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Pipeline State (according to enum values)  <a href="classMediaBlackbox.html#aa267457fa1d640a4a92da0588b875454">More...</a><br /></td></tr>
<tr class="separator:aa267457fa1d640a4a92da0588b875454"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-static-methods"></a>
Static Protected Member Functions</h2></td></tr>
<tr class="memitem:afcaba1d1bbd3bcec069ac5d8f110ef2e"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMediaBlackbox.html#afcaba1d1bbd3bcec069ac5d8f110ef2e">decode_pad_added_handler</a> (GstElement *src, GstPad *new_pad, <a class="el" href="classMediaBlackbox.html">MediaBlackbox</a> *data)</td></tr>
<tr class="memdesc:afcaba1d1bbd3bcec069ac5d8f110ef2e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Callback handler for the added pad on uridecodebin.  <a href="classMediaBlackbox.html#afcaba1d1bbd3bcec069ac5d8f110ef2e">More...</a><br /></td></tr>
<tr class="separator:afcaba1d1bbd3bcec069ac5d8f110ef2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a816690f94dbf719181057d74e12c8b9d"><td class="memItemLeft" align="right" valign="top"><a id="a816690f94dbf719181057d74e12c8b9d"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>source</b></td></tr>
<tr class="separator:a816690f94dbf719181057d74e12c8b9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a01ae378a2f32ba1cefb4d6837a919eec"><td class="memItemLeft" align="right" valign="top"><a id="a01ae378a2f32ba1cefb4d6837a919eec"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>video_balance</b></td></tr>
<tr class="separator:a01ae378a2f32ba1cefb4d6837a919eec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac54982cf05440624c7097dce89d4b5da"><td class="memItemLeft" align="right" valign="top"><a id="ac54982cf05440624c7097dce89d4b5da"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>audio_convert</b></td></tr>
<tr class="separator:ac54982cf05440624c7097dce89d4b5da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8769511f5c30ed3fe8131088685be834"><td class="memItemLeft" align="right" valign="top"><a id="a8769511f5c30ed3fe8131088685be834"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>video_convert</b></td></tr>
<tr class="separator:a8769511f5c30ed3fe8131088685be834"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0b255736b1c9b45ca2c593fa064797f"><td class="memItemLeft" align="right" valign="top"><a id="aa0b255736b1c9b45ca2c593fa064797f"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>audio_resample</b></td></tr>
<tr class="separator:aa0b255736b1c9b45ca2c593fa064797f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f252da9e0adfd6d048644d95bd63f82"><td class="memItemLeft" align="right" valign="top"><a id="a9f252da9e0adfd6d048644d95bd63f82"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>videosink</b></td></tr>
<tr class="separator:a9f252da9e0adfd6d048644d95bd63f82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c1f40630b8268f8f9842e57faf75b75"><td class="memItemLeft" align="right" valign="top"><a id="a5c1f40630b8268f8f9842e57faf75b75"></a>
<a class="el" href="classgst_1_1Element.html">gst::Element</a>&#160;</td><td class="memItemRight" valign="bottom"><b>audiosink</b></td></tr>
<tr class="separator:a5c1f40630b8268f8f9842e57faf75b75"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6775aed081e1453f302aa07a3f95b54d"><td class="memItemLeft" align="right" valign="top"><a id="a6775aed081e1453f302aa07a3f95b54d"></a>
<a class="el" href="classgst_1_1Pipeline.html">gst::Pipeline</a>&#160;</td><td class="memItemRight" valign="bottom"><b>pipeline</b></td></tr>
<tr class="separator:a6775aed081e1453f302aa07a3f95b54d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4757e0d43f14f770a907880f858b2789"><td class="memItemLeft" align="right" valign="top"><a id="a4757e0d43f14f770a907880f858b2789"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><b>current_path</b></td></tr>
<tr class="separator:a4757e0d43f14f770a907880f858b2789"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Media API class Creates a pipeline internally and provides methods to start, stop and set media sources. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="afcaba1d1bbd3bcec069ac5d8f110ef2e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afcaba1d1bbd3bcec069ac5d8f110ef2e">&#9670;&nbsp;</a></span>decode_pad_added_handler()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MediaBlackbox::decode_pad_added_handler </td>
          <td>(</td>
          <td class="paramtype">GstElement *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GstPad *&#160;</td>
          <td class="paramname"><em>_new_pad</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classMediaBlackbox.html">MediaBlackbox</a> *&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Callback handler for the added pad on uridecodebin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>the uridecodebin as GstElement* </td></tr>
    <tr><td class="paramname">new_pad</td><td>the new pad added on the uridecodebin </td></tr>
    <tr><td class="paramname">data</td><td>the mediablackbox for simpler pipeline access </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">Referenced by <a class="el" href="classMediaBlackbox.html#a9fc612bd5058aaccc9134e2965a5b125">MediaBlackbox()</a>.</p>
<div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><iframe scrolling="no" frameborder="0" src="classMediaBlackbox_afcaba1d1bbd3bcec069ac5d8f110ef2e_icgraph.svg" width="467" height="52"><p><b>This browser is not able to show SVG: try Firefox, Chrome, Safari, or Opera instead.</b></p></iframe>
</div>
</div>

</div>
</div>
<a id="aa267457fa1d640a4a92da0588b875454"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa267457fa1d640a4a92da0588b875454">&#9670;&nbsp;</a></span>get_pipeline_state()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">gst::State MediaBlackbox::get_pipeline_state </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Pipeline State (according to enum values) </p>
<dl class="section return"><dt>Returns</dt><dd>enum State </dd></dl>

</div>
</div>
<a id="a62c6e8f750e5ed03862f6b09c3ec9811"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a62c6e8f750e5ed03862f6b09c3ec9811">&#9670;&nbsp;</a></span>set_media_src()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MediaBlackbox::set_media_src </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>file_path</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Setting the currently selected. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">file_path</td><td>file path to a media file on the disk (relative to executable allowed) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="media__framework_8hpp_source.html">media_framework.hpp</a></li>
<li><a class="el" href="media__framework_8cpp.html">media_framework.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classMediaBlackbox.html">MediaBlackbox</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
